%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% test of Gammatone filterbank
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% version 1
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Basic features:
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Author : L. Girin - GIPSA-lab
% Last update : 2012-06-5
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all; close all; clc; tic;
homedir = '/Users/girinl/Laurent/INRIA/';  % for Mac
file = 'static5a.wav'; 
cd([homedir]);

[x,Fs,Nb] = wavread(file);
sel = 24*Fs+1:44*Fs;
x1 = x(sel,1)';
x2 = x(sel,2)';
clear x;

%[y1,ENVS,INSTFS]=gammatonebank(x1,0,Fs/2,16,Fs);
%[y2,ENVS,INSTFS]=gammatonebank(x1,0,Fs/2,16,Fs);

L = length(x1);
H = 256;
N = 512;
K = fix(L/H)-1;

C = zeros(2*N-1,K);
C_f = C;

%b = fir1(100,300/Fs*2); a=1;
[b,a] = ellip(5,0.1,50,250*2/Fs);
x1_f = filtfilt(b,a,x1);
x2_f = filtfilt(b,a,x2);

for k = 0:K-1
    
    z1 = x1(1+k*H:N+k*H);
    z2 = x2(1+k*H:N+k*H);
    
    z1_f = x1_f(1+k*H:N+k*H);
    z2_f = x2_f(1+k*H:N+k*H);
    
    c = xcorr(z1,z2);
    c = c/max(abs(c));
    C(:,k+1) = c;
    
    c_f = xcorr(z1_f,z2_f);
    c_f = c_f/max(abs(c_f));
    C_f(:,k+1) = c_f;
    
end;

figure(1); clf;
imagesc(C);

figure(2); clf;
imagesc(C_f);


    
    
    
    

