function param = ParamGMR(model,sizeY)

%Calculation of the linear regression parameters (Ak and bk)
%and pi,muX and SigmaXX for later
sizeX = size(model.mu,1) - sizeY;
param.A = [];
param.b = [];
param.pi = [];
param.muX = [];
param.SigmaXX = [];

% Loop on each gaussian function
for k = 1:size(model.mu,2)
    
    % Previous parameters
    muX = model.mu(1:sizeX,k);
    muY = model.mu(sizeX+1:sizeX+sizeY,k);
    
    SigmaXX = model.Sigma(1:sizeX,1:sizeX,k);
    SigmaYY = model.Sigma(sizeX+1:sizeX+sizeY,sizeX+1:sizeX+sizeY,k);
    SigmaXY = model.Sigma(1:sizeX,sizeX+1:sizeX+sizeY,k);
    SigmaYX = model.Sigma(sizeX+1:sizeX+sizeY,1:sizeX,k);
    
    % Inversion of sigmaXX
    invSigmaXX = inv(SigmaXX);
    
    % New parameters calculation
    A = SigmaYX * invSigmaXX;
    b = muY - SigmaYX * invSigmaXX * muX;
    
    % Assignation
    param.A(:,:,k) = A;
    param.b(:,:,k) = b;
    param.pi(:,:,k) = model.weight(k);
    param.muX(:,:,k) = muX;
    param.SigmaXX(:,:,k) = SigmaXX;
    
end

end


