close all
clear all

numData = input('Which Dataset ? ');
numFilter = input('How many Gammatone filter ? ');
if isempty(numFilter)
    numFilter = 16;
end
maxRange = input('What range for the azimuth angle ? ([-X°,X°],160° is good) ');
if isempty(maxRange)
    maxRange = 160;
end
ITD16 = input('Use the delays calculated with the limited crosscorelation (1) or with the whole crosscorelation (0) ?');
if isempty(ITD16)
    ITD16 = 0;
end
trust = input('Use the maximum of crosscorelation as a trust value (1) or not (0) ?');
if isempty(trust)
    trust = 1;
end
maxGauss = input('Maximum number of Gaussian function in the GMM (128 is good) ? ');
if isempty(maxGauss)
    maxGauss = 128;
end

% Loading the data matrix
load(['./Data/Data_' int2str(numFilter) 'Gammatone_Dataset' int2str(numData) ]);

% Initializing the new matrix
if trust
WN_data2 = zeros(3*numFilter+2,size(WN_data,2));
Sp_data2 = zeros(3*numFilter+2,size(Sp_data,2));
else
WN_data2 = zeros(2*numFilter+2,size(WN_data,2));
Sp_data2 = zeros(2*numFilter+2,size(Sp_data,2));    
end

% We select the angles in the range [-maxRang°,+maxRange°]
colWN = 0;
for i = 1:size(WN_data,2)
    if WN_data(6*numFilter+3,i)<maxRange && WN_data(6*numFilter+3,i)>-maxRange
        colWN = colWN+1;
        WN_dataLim(:,colWN) = WN_data(:,i);
    end
end
WN_data2 = WN_data2(:,1:colWN);
colSp = 0;
for i = 1:size(WN_data,2)
    if Sp_data(6*numFilter+3,i)<maxRange && Sp_data(6*numFilter+3,i)>-maxRange
        colSp = colSp+1;
        Sp_dataLim(:,colSp) = WN_data(:,i);
    end
end
Sp_data2 = Sp_data2(:,1:colSp);


% ILD (energy3/energy4)
WN_data2(1:numFilter,:) = WN_dataLim(1:numFilter,:)./WN_dataLim(numFilter+1:2*numFilter,:);
Sp_data2(1:numFilter,:) = Sp_dataLim(1:numFilter,:)./Sp_dataLim(numFilter+1:2*numFilter,:);

% ITD
if not(ITD16)
    WN_data2(numFilter+1:2*numFilter,:) = WN_dataLim(2*numFilter+1:3*numFilter,:);
    Sp_data2(numFilter+1:2*numFilter,:) = Sp_dataLim(2*numFilter+1:3*numFilter,:);
else
    WN_data2(numFilter+1:2*numFilter,:) = WN_dataLim(3*numFilter+1:4*numFilter,:);
    Sp_data2(numFilter+1:2*numFilter,:) = Sp_dataLim(3*numFilter+1:4*numFilter,:);
end

% trust value and source angle
if trust
    if not(ITD16)
        WN_data2(2*numFilter+1:3*numFilter,:) = WN_dataLim(4*numFilter+1:5*numFilter,:);
        Sp_data2(2*numFilter+1:3*numFilter,:) = Sp_dataLim(4*numFilter+1:5*numFilter,:);
    else
        WN_data2(2*numFilter+1:3*numFilter,:) = WN_dataLim(5*numFilter+1:6*numFilter,:);
        Sp_data2(2*numFilter+1:3*numFilter,:) = Sp_dataLim(5*numFilter+1:6*numFilter,:);
    end
    WN_data2(3*numFilter+1:3*numFilter+2,:) = WN_dataLim(6*numFilter+3:6*numFilter+4,:);
    Sp_data2(3*numFilter+1:3*numFilter+2,:) = Sp_dataLim(6*numFilter+3:6*numFilter+4,:);
else
    WN_data2(2*numFilter+1:2*numFilter+2,:) = WN_dataLim(6*numFilter+3:6*numFilter+4,:);
    Sp_data2(2*numFilter+1:2*numFilter+2,:) = Sp_dataLim(6*numFilter+3:6*numFilter+4,:); 
end

% GMR Learning and test 
[yEstim,yTest,EQM] = LearnTest(WN_data2,Sp_data2,maxGauss);

% Saving the results
save(['./Results/Results_' int2str(numFilter) 'Gammatone_Dataset' int2str(numData) '_maxRange = ' int2str(maxRange) '_ITD16 = ' int2str(ITD16) '_trust = ' int2str(trust) ],'yEstim','yTest','EQM')
