function [yEstim,yTest,EQM] = inference(Sp_data, param)

[sizeY,sizeX,K] = size(param.A);
N = size(Sp_data,2);

xTest = Sp_data(1:sizeX,:);
yTest = Sp_data(sizeX+1:sizeX+sizeY,:);
sumNx = zeros(1,N);

% X distibution
for k = 1:K
    Nx(:,:,k) = transpose(gaussPDF(xTest, param.muX(:,:,k), param.SigmaXX(:,:,k)));
    sumNx = sumNx + param.pi(:,:,k).*Nx(:,:,k);
end

% Y estimation
for k = 1:K
    yEstim(:,:,k) = repmat(param.pi(:,:,k).*Nx(:,:,k)./sumNx,sizeY,1).*(param.A(:,:,k)*xTest+repmat(param.b(:,:,k),1,N));
end
yEstim = sum(yEstim,3);

% Angles unfolding
for i = 1:N
    while yEstim(1,i)<-180 || yEstim(1,i)>180
        if yEstim(1,i)<-180
            yEstim(1,i) = yEstim(1,i)+360;
        elseif yEstim(1,i)>180
            yEstim(1,i) = yEstim(1,i)-360;
        end
    end
end

% EQM calculation
EQM = mean((yEstim - yTest).^2,2);
